/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
	"time"
)

// checks if the OperationAudit type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OperationAudit{}

// OperationAudit struct for OperationAudit
type OperationAudit struct {
	Time                *time.Time           `json:"time,omitempty"`
	IdentityId          NullableString       `json:"identityId,omitempty"`
	DisplayName         NullableString       `json:"displayName,omitempty"`
	AccountId           NullableString       `json:"accountId,omitempty"`
	ApplicationId       NullableString       `json:"applicationId,omitempty"`
	IpAddress           NullableString       `json:"ipAddress,omitempty"`
	OperationType       NullableString       `json:"operationType,omitempty"`
	Authorized          *AuthorizationStatus `json:"authorized,omitempty"`
	AuthorizationReason NullableString       `json:"authorizationReason,omitempty"`
	Success             *bool                `json:"success,omitempty"`
	Reason              NullableString       `json:"reason,omitempty"`
	Description         NullableString       `json:"description,omitempty"`
	TargetObjectType1   NullableString       `json:"targetObjectType1,omitempty"`
	TargetObjectId1     NullableString       `json:"targetObjectId1,omitempty"`
	TargetObject1       NullableString       `json:"targetObject1,omitempty"`
	TargetObjectType2   NullableString       `json:"targetObjectType2,omitempty"`
	TargetObject2       NullableString       `json:"targetObject2,omitempty"`
	TargetObjectId2     NullableString       `json:"targetObjectId2,omitempty"`
	ParentObjectType    NullableString       `json:"parentObjectType,omitempty"`
	ParentObjectId      NullableString       `json:"parentObjectId,omitempty"`
	ParentObject        NullableString       `json:"parentObject,omitempty"`
	Id                  NullableString       `json:"id,omitempty"`
	CreationTime        *time.Time           `json:"creationTime,omitempty"`
}

// NewOperationAudit instantiates a new OperationAudit object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOperationAudit() *OperationAudit {
	this := OperationAudit{}
	return &this
}

// NewOperationAuditWithDefaults instantiates a new OperationAudit object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOperationAuditWithDefaults() *OperationAudit {
	this := OperationAudit{}
	return &this
}

// GetTime returns the Time field value if set, zero value otherwise.
func (o *OperationAudit) GetTime() time.Time {
	if o == nil || IsNil(o.Time) {
		var ret time.Time
		return ret
	}
	return *o.Time
}

// GetTimeOk returns a tuple with the Time field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OperationAudit) GetTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.Time) {
		return nil, false
	}
	return o.Time, true
}

// HasTime returns a boolean if a field has been set.
func (o *OperationAudit) HasTime() bool {
	if o != nil && !IsNil(o.Time) {
		return true
	}

	return false
}

// SetTime gets a reference to the given time.Time and assigns it to the Time field.
func (o *OperationAudit) SetTime(v time.Time) {
	o.Time = &v
}

// GetIdentityId returns the IdentityId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetIdentityId() string {
	if o == nil || IsNil(o.IdentityId.Get()) {
		var ret string
		return ret
	}
	return *o.IdentityId.Get()
}

// GetIdentityIdOk returns a tuple with the IdentityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetIdentityIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IdentityId.Get(), o.IdentityId.IsSet()
}

// HasIdentityId returns a boolean if a field has been set.
func (o *OperationAudit) HasIdentityId() bool {
	if o != nil && o.IdentityId.IsSet() {
		return true
	}

	return false
}

// SetIdentityId gets a reference to the given NullableString and assigns it to the IdentityId field.
func (o *OperationAudit) SetIdentityId(v string) {
	o.IdentityId.Set(&v)
}

// SetIdentityIdNil sets the value for IdentityId to be an explicit nil
func (o *OperationAudit) SetIdentityIdNil() {
	o.IdentityId.Set(nil)
}

// UnsetIdentityId ensures that no value is present for IdentityId, not even an explicit nil
func (o *OperationAudit) UnsetIdentityId() {
	o.IdentityId.Unset()
}

// GetDisplayName returns the DisplayName field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetDisplayName() string {
	if o == nil || IsNil(o.DisplayName.Get()) {
		var ret string
		return ret
	}
	return *o.DisplayName.Get()
}

// GetDisplayNameOk returns a tuple with the DisplayName field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetDisplayNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DisplayName.Get(), o.DisplayName.IsSet()
}

// HasDisplayName returns a boolean if a field has been set.
func (o *OperationAudit) HasDisplayName() bool {
	if o != nil && o.DisplayName.IsSet() {
		return true
	}

	return false
}

// SetDisplayName gets a reference to the given NullableString and assigns it to the DisplayName field.
func (o *OperationAudit) SetDisplayName(v string) {
	o.DisplayName.Set(&v)
}

// SetDisplayNameNil sets the value for DisplayName to be an explicit nil
func (o *OperationAudit) SetDisplayNameNil() {
	o.DisplayName.Set(nil)
}

// UnsetDisplayName ensures that no value is present for DisplayName, not even an explicit nil
func (o *OperationAudit) UnsetDisplayName() {
	o.DisplayName.Unset()
}

// GetAccountId returns the AccountId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetAccountId() string {
	if o == nil || IsNil(o.AccountId.Get()) {
		var ret string
		return ret
	}
	return *o.AccountId.Get()
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetAccountIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AccountId.Get(), o.AccountId.IsSet()
}

// HasAccountId returns a boolean if a field has been set.
func (o *OperationAudit) HasAccountId() bool {
	if o != nil && o.AccountId.IsSet() {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given NullableString and assigns it to the AccountId field.
func (o *OperationAudit) SetAccountId(v string) {
	o.AccountId.Set(&v)
}

// SetAccountIdNil sets the value for AccountId to be an explicit nil
func (o *OperationAudit) SetAccountIdNil() {
	o.AccountId.Set(nil)
}

// UnsetAccountId ensures that no value is present for AccountId, not even an explicit nil
func (o *OperationAudit) UnsetAccountId() {
	o.AccountId.Unset()
}

// GetApplicationId returns the ApplicationId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetApplicationId() string {
	if o == nil || IsNil(o.ApplicationId.Get()) {
		var ret string
		return ret
	}
	return *o.ApplicationId.Get()
}

// GetApplicationIdOk returns a tuple with the ApplicationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetApplicationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ApplicationId.Get(), o.ApplicationId.IsSet()
}

// HasApplicationId returns a boolean if a field has been set.
func (o *OperationAudit) HasApplicationId() bool {
	if o != nil && o.ApplicationId.IsSet() {
		return true
	}

	return false
}

// SetApplicationId gets a reference to the given NullableString and assigns it to the ApplicationId field.
func (o *OperationAudit) SetApplicationId(v string) {
	o.ApplicationId.Set(&v)
}

// SetApplicationIdNil sets the value for ApplicationId to be an explicit nil
func (o *OperationAudit) SetApplicationIdNil() {
	o.ApplicationId.Set(nil)
}

// UnsetApplicationId ensures that no value is present for ApplicationId, not even an explicit nil
func (o *OperationAudit) UnsetApplicationId() {
	o.ApplicationId.Unset()
}

// GetIpAddress returns the IpAddress field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetIpAddress() string {
	if o == nil || IsNil(o.IpAddress.Get()) {
		var ret string
		return ret
	}
	return *o.IpAddress.Get()
}

// GetIpAddressOk returns a tuple with the IpAddress field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetIpAddressOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.IpAddress.Get(), o.IpAddress.IsSet()
}

// HasIpAddress returns a boolean if a field has been set.
func (o *OperationAudit) HasIpAddress() bool {
	if o != nil && o.IpAddress.IsSet() {
		return true
	}

	return false
}

// SetIpAddress gets a reference to the given NullableString and assigns it to the IpAddress field.
func (o *OperationAudit) SetIpAddress(v string) {
	o.IpAddress.Set(&v)
}

// SetIpAddressNil sets the value for IpAddress to be an explicit nil
func (o *OperationAudit) SetIpAddressNil() {
	o.IpAddress.Set(nil)
}

// UnsetIpAddress ensures that no value is present for IpAddress, not even an explicit nil
func (o *OperationAudit) UnsetIpAddress() {
	o.IpAddress.Unset()
}

// GetOperationType returns the OperationType field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetOperationType() string {
	if o == nil || IsNil(o.OperationType.Get()) {
		var ret string
		return ret
	}
	return *o.OperationType.Get()
}

// GetOperationTypeOk returns a tuple with the OperationType field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetOperationTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.OperationType.Get(), o.OperationType.IsSet()
}

// HasOperationType returns a boolean if a field has been set.
func (o *OperationAudit) HasOperationType() bool {
	if o != nil && o.OperationType.IsSet() {
		return true
	}

	return false
}

// SetOperationType gets a reference to the given NullableString and assigns it to the OperationType field.
func (o *OperationAudit) SetOperationType(v string) {
	o.OperationType.Set(&v)
}

// SetOperationTypeNil sets the value for OperationType to be an explicit nil
func (o *OperationAudit) SetOperationTypeNil() {
	o.OperationType.Set(nil)
}

// UnsetOperationType ensures that no value is present for OperationType, not even an explicit nil
func (o *OperationAudit) UnsetOperationType() {
	o.OperationType.Unset()
}

// GetAuthorized returns the Authorized field value if set, zero value otherwise.
func (o *OperationAudit) GetAuthorized() AuthorizationStatus {
	if o == nil || IsNil(o.Authorized) {
		var ret AuthorizationStatus
		return ret
	}
	return *o.Authorized
}

// GetAuthorizedOk returns a tuple with the Authorized field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OperationAudit) GetAuthorizedOk() (*AuthorizationStatus, bool) {
	if o == nil || IsNil(o.Authorized) {
		return nil, false
	}
	return o.Authorized, true
}

// HasAuthorized returns a boolean if a field has been set.
func (o *OperationAudit) HasAuthorized() bool {
	if o != nil && !IsNil(o.Authorized) {
		return true
	}

	return false
}

// SetAuthorized gets a reference to the given AuthorizationStatus and assigns it to the Authorized field.
func (o *OperationAudit) SetAuthorized(v AuthorizationStatus) {
	o.Authorized = &v
}

// GetAuthorizationReason returns the AuthorizationReason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetAuthorizationReason() string {
	if o == nil || IsNil(o.AuthorizationReason.Get()) {
		var ret string
		return ret
	}
	return *o.AuthorizationReason.Get()
}

// GetAuthorizationReasonOk returns a tuple with the AuthorizationReason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetAuthorizationReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AuthorizationReason.Get(), o.AuthorizationReason.IsSet()
}

// HasAuthorizationReason returns a boolean if a field has been set.
func (o *OperationAudit) HasAuthorizationReason() bool {
	if o != nil && o.AuthorizationReason.IsSet() {
		return true
	}

	return false
}

// SetAuthorizationReason gets a reference to the given NullableString and assigns it to the AuthorizationReason field.
func (o *OperationAudit) SetAuthorizationReason(v string) {
	o.AuthorizationReason.Set(&v)
}

// SetAuthorizationReasonNil sets the value for AuthorizationReason to be an explicit nil
func (o *OperationAudit) SetAuthorizationReasonNil() {
	o.AuthorizationReason.Set(nil)
}

// UnsetAuthorizationReason ensures that no value is present for AuthorizationReason, not even an explicit nil
func (o *OperationAudit) UnsetAuthorizationReason() {
	o.AuthorizationReason.Unset()
}

// GetSuccess returns the Success field value if set, zero value otherwise.
func (o *OperationAudit) GetSuccess() bool {
	if o == nil || IsNil(o.Success) {
		var ret bool
		return ret
	}
	return *o.Success
}

// GetSuccessOk returns a tuple with the Success field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OperationAudit) GetSuccessOk() (*bool, bool) {
	if o == nil || IsNil(o.Success) {
		return nil, false
	}
	return o.Success, true
}

// HasSuccess returns a boolean if a field has been set.
func (o *OperationAudit) HasSuccess() bool {
	if o != nil && !IsNil(o.Success) {
		return true
	}

	return false
}

// SetSuccess gets a reference to the given bool and assigns it to the Success field.
func (o *OperationAudit) SetSuccess(v bool) {
	o.Success = &v
}

// GetReason returns the Reason field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetReason() string {
	if o == nil || IsNil(o.Reason.Get()) {
		var ret string
		return ret
	}
	return *o.Reason.Get()
}

// GetReasonOk returns a tuple with the Reason field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetReasonOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Reason.Get(), o.Reason.IsSet()
}

// HasReason returns a boolean if a field has been set.
func (o *OperationAudit) HasReason() bool {
	if o != nil && o.Reason.IsSet() {
		return true
	}

	return false
}

// SetReason gets a reference to the given NullableString and assigns it to the Reason field.
func (o *OperationAudit) SetReason(v string) {
	o.Reason.Set(&v)
}

// SetReasonNil sets the value for Reason to be an explicit nil
func (o *OperationAudit) SetReasonNil() {
	o.Reason.Set(nil)
}

// UnsetReason ensures that no value is present for Reason, not even an explicit nil
func (o *OperationAudit) UnsetReason() {
	o.Reason.Unset()
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *OperationAudit) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *OperationAudit) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *OperationAudit) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *OperationAudit) UnsetDescription() {
	o.Description.Unset()
}

// GetTargetObjectType1 returns the TargetObjectType1 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetTargetObjectType1() string {
	if o == nil || IsNil(o.TargetObjectType1.Get()) {
		var ret string
		return ret
	}
	return *o.TargetObjectType1.Get()
}

// GetTargetObjectType1Ok returns a tuple with the TargetObjectType1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetTargetObjectType1Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetObjectType1.Get(), o.TargetObjectType1.IsSet()
}

// HasTargetObjectType1 returns a boolean if a field has been set.
func (o *OperationAudit) HasTargetObjectType1() bool {
	if o != nil && o.TargetObjectType1.IsSet() {
		return true
	}

	return false
}

// SetTargetObjectType1 gets a reference to the given NullableString and assigns it to the TargetObjectType1 field.
func (o *OperationAudit) SetTargetObjectType1(v string) {
	o.TargetObjectType1.Set(&v)
}

// SetTargetObjectType1Nil sets the value for TargetObjectType1 to be an explicit nil
func (o *OperationAudit) SetTargetObjectType1Nil() {
	o.TargetObjectType1.Set(nil)
}

// UnsetTargetObjectType1 ensures that no value is present for TargetObjectType1, not even an explicit nil
func (o *OperationAudit) UnsetTargetObjectType1() {
	o.TargetObjectType1.Unset()
}

// GetTargetObjectId1 returns the TargetObjectId1 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetTargetObjectId1() string {
	if o == nil || IsNil(o.TargetObjectId1.Get()) {
		var ret string
		return ret
	}
	return *o.TargetObjectId1.Get()
}

// GetTargetObjectId1Ok returns a tuple with the TargetObjectId1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetTargetObjectId1Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetObjectId1.Get(), o.TargetObjectId1.IsSet()
}

// HasTargetObjectId1 returns a boolean if a field has been set.
func (o *OperationAudit) HasTargetObjectId1() bool {
	if o != nil && o.TargetObjectId1.IsSet() {
		return true
	}

	return false
}

// SetTargetObjectId1 gets a reference to the given NullableString and assigns it to the TargetObjectId1 field.
func (o *OperationAudit) SetTargetObjectId1(v string) {
	o.TargetObjectId1.Set(&v)
}

// SetTargetObjectId1Nil sets the value for TargetObjectId1 to be an explicit nil
func (o *OperationAudit) SetTargetObjectId1Nil() {
	o.TargetObjectId1.Set(nil)
}

// UnsetTargetObjectId1 ensures that no value is present for TargetObjectId1, not even an explicit nil
func (o *OperationAudit) UnsetTargetObjectId1() {
	o.TargetObjectId1.Unset()
}

// GetTargetObject1 returns the TargetObject1 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetTargetObject1() string {
	if o == nil || IsNil(o.TargetObject1.Get()) {
		var ret string
		return ret
	}
	return *o.TargetObject1.Get()
}

// GetTargetObject1Ok returns a tuple with the TargetObject1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetTargetObject1Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetObject1.Get(), o.TargetObject1.IsSet()
}

// HasTargetObject1 returns a boolean if a field has been set.
func (o *OperationAudit) HasTargetObject1() bool {
	if o != nil && o.TargetObject1.IsSet() {
		return true
	}

	return false
}

// SetTargetObject1 gets a reference to the given NullableString and assigns it to the TargetObject1 field.
func (o *OperationAudit) SetTargetObject1(v string) {
	o.TargetObject1.Set(&v)
}

// SetTargetObject1Nil sets the value for TargetObject1 to be an explicit nil
func (o *OperationAudit) SetTargetObject1Nil() {
	o.TargetObject1.Set(nil)
}

// UnsetTargetObject1 ensures that no value is present for TargetObject1, not even an explicit nil
func (o *OperationAudit) UnsetTargetObject1() {
	o.TargetObject1.Unset()
}

// GetTargetObjectType2 returns the TargetObjectType2 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetTargetObjectType2() string {
	if o == nil || IsNil(o.TargetObjectType2.Get()) {
		var ret string
		return ret
	}
	return *o.TargetObjectType2.Get()
}

// GetTargetObjectType2Ok returns a tuple with the TargetObjectType2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetTargetObjectType2Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetObjectType2.Get(), o.TargetObjectType2.IsSet()
}

// HasTargetObjectType2 returns a boolean if a field has been set.
func (o *OperationAudit) HasTargetObjectType2() bool {
	if o != nil && o.TargetObjectType2.IsSet() {
		return true
	}

	return false
}

// SetTargetObjectType2 gets a reference to the given NullableString and assigns it to the TargetObjectType2 field.
func (o *OperationAudit) SetTargetObjectType2(v string) {
	o.TargetObjectType2.Set(&v)
}

// SetTargetObjectType2Nil sets the value for TargetObjectType2 to be an explicit nil
func (o *OperationAudit) SetTargetObjectType2Nil() {
	o.TargetObjectType2.Set(nil)
}

// UnsetTargetObjectType2 ensures that no value is present for TargetObjectType2, not even an explicit nil
func (o *OperationAudit) UnsetTargetObjectType2() {
	o.TargetObjectType2.Unset()
}

// GetTargetObject2 returns the TargetObject2 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetTargetObject2() string {
	if o == nil || IsNil(o.TargetObject2.Get()) {
		var ret string
		return ret
	}
	return *o.TargetObject2.Get()
}

// GetTargetObject2Ok returns a tuple with the TargetObject2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetTargetObject2Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetObject2.Get(), o.TargetObject2.IsSet()
}

// HasTargetObject2 returns a boolean if a field has been set.
func (o *OperationAudit) HasTargetObject2() bool {
	if o != nil && o.TargetObject2.IsSet() {
		return true
	}

	return false
}

// SetTargetObject2 gets a reference to the given NullableString and assigns it to the TargetObject2 field.
func (o *OperationAudit) SetTargetObject2(v string) {
	o.TargetObject2.Set(&v)
}

// SetTargetObject2Nil sets the value for TargetObject2 to be an explicit nil
func (o *OperationAudit) SetTargetObject2Nil() {
	o.TargetObject2.Set(nil)
}

// UnsetTargetObject2 ensures that no value is present for TargetObject2, not even an explicit nil
func (o *OperationAudit) UnsetTargetObject2() {
	o.TargetObject2.Unset()
}

// GetTargetObjectId2 returns the TargetObjectId2 field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetTargetObjectId2() string {
	if o == nil || IsNil(o.TargetObjectId2.Get()) {
		var ret string
		return ret
	}
	return *o.TargetObjectId2.Get()
}

// GetTargetObjectId2Ok returns a tuple with the TargetObjectId2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetTargetObjectId2Ok() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.TargetObjectId2.Get(), o.TargetObjectId2.IsSet()
}

// HasTargetObjectId2 returns a boolean if a field has been set.
func (o *OperationAudit) HasTargetObjectId2() bool {
	if o != nil && o.TargetObjectId2.IsSet() {
		return true
	}

	return false
}

// SetTargetObjectId2 gets a reference to the given NullableString and assigns it to the TargetObjectId2 field.
func (o *OperationAudit) SetTargetObjectId2(v string) {
	o.TargetObjectId2.Set(&v)
}

// SetTargetObjectId2Nil sets the value for TargetObjectId2 to be an explicit nil
func (o *OperationAudit) SetTargetObjectId2Nil() {
	o.TargetObjectId2.Set(nil)
}

// UnsetTargetObjectId2 ensures that no value is present for TargetObjectId2, not even an explicit nil
func (o *OperationAudit) UnsetTargetObjectId2() {
	o.TargetObjectId2.Unset()
}

// GetParentObjectType returns the ParentObjectType field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetParentObjectType() string {
	if o == nil || IsNil(o.ParentObjectType.Get()) {
		var ret string
		return ret
	}
	return *o.ParentObjectType.Get()
}

// GetParentObjectTypeOk returns a tuple with the ParentObjectType field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetParentObjectTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ParentObjectType.Get(), o.ParentObjectType.IsSet()
}

// HasParentObjectType returns a boolean if a field has been set.
func (o *OperationAudit) HasParentObjectType() bool {
	if o != nil && o.ParentObjectType.IsSet() {
		return true
	}

	return false
}

// SetParentObjectType gets a reference to the given NullableString and assigns it to the ParentObjectType field.
func (o *OperationAudit) SetParentObjectType(v string) {
	o.ParentObjectType.Set(&v)
}

// SetParentObjectTypeNil sets the value for ParentObjectType to be an explicit nil
func (o *OperationAudit) SetParentObjectTypeNil() {
	o.ParentObjectType.Set(nil)
}

// UnsetParentObjectType ensures that no value is present for ParentObjectType, not even an explicit nil
func (o *OperationAudit) UnsetParentObjectType() {
	o.ParentObjectType.Unset()
}

// GetParentObjectId returns the ParentObjectId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetParentObjectId() string {
	if o == nil || IsNil(o.ParentObjectId.Get()) {
		var ret string
		return ret
	}
	return *o.ParentObjectId.Get()
}

// GetParentObjectIdOk returns a tuple with the ParentObjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetParentObjectIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ParentObjectId.Get(), o.ParentObjectId.IsSet()
}

// HasParentObjectId returns a boolean if a field has been set.
func (o *OperationAudit) HasParentObjectId() bool {
	if o != nil && o.ParentObjectId.IsSet() {
		return true
	}

	return false
}

// SetParentObjectId gets a reference to the given NullableString and assigns it to the ParentObjectId field.
func (o *OperationAudit) SetParentObjectId(v string) {
	o.ParentObjectId.Set(&v)
}

// SetParentObjectIdNil sets the value for ParentObjectId to be an explicit nil
func (o *OperationAudit) SetParentObjectIdNil() {
	o.ParentObjectId.Set(nil)
}

// UnsetParentObjectId ensures that no value is present for ParentObjectId, not even an explicit nil
func (o *OperationAudit) UnsetParentObjectId() {
	o.ParentObjectId.Unset()
}

// GetParentObject returns the ParentObject field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetParentObject() string {
	if o == nil || IsNil(o.ParentObject.Get()) {
		var ret string
		return ret
	}
	return *o.ParentObject.Get()
}

// GetParentObjectOk returns a tuple with the ParentObject field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetParentObjectOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ParentObject.Get(), o.ParentObject.IsSet()
}

// HasParentObject returns a boolean if a field has been set.
func (o *OperationAudit) HasParentObject() bool {
	if o != nil && o.ParentObject.IsSet() {
		return true
	}

	return false
}

// SetParentObject gets a reference to the given NullableString and assigns it to the ParentObject field.
func (o *OperationAudit) SetParentObject(v string) {
	o.ParentObject.Set(&v)
}

// SetParentObjectNil sets the value for ParentObject to be an explicit nil
func (o *OperationAudit) SetParentObjectNil() {
	o.ParentObject.Set(nil)
}

// UnsetParentObject ensures that no value is present for ParentObject, not even an explicit nil
func (o *OperationAudit) UnsetParentObject() {
	o.ParentObject.Unset()
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *OperationAudit) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *OperationAudit) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *OperationAudit) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *OperationAudit) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *OperationAudit) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *OperationAudit) UnsetId() {
	o.Id.Unset()
}

// GetCreationTime returns the CreationTime field value if set, zero value otherwise.
func (o *OperationAudit) GetCreationTime() time.Time {
	if o == nil || IsNil(o.CreationTime) {
		var ret time.Time
		return ret
	}
	return *o.CreationTime
}

// GetCreationTimeOk returns a tuple with the CreationTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *OperationAudit) GetCreationTimeOk() (*time.Time, bool) {
	if o == nil || IsNil(o.CreationTime) {
		return nil, false
	}
	return o.CreationTime, true
}

// HasCreationTime returns a boolean if a field has been set.
func (o *OperationAudit) HasCreationTime() bool {
	if o != nil && !IsNil(o.CreationTime) {
		return true
	}

	return false
}

// SetCreationTime gets a reference to the given time.Time and assigns it to the CreationTime field.
func (o *OperationAudit) SetCreationTime(v time.Time) {
	o.CreationTime = &v
}

func (o OperationAudit) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OperationAudit) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Time) {
		toSerialize["time"] = o.Time
	}
	if o.IdentityId.IsSet() {
		toSerialize["identityId"] = o.IdentityId.Get()
	}
	if o.DisplayName.IsSet() {
		toSerialize["displayName"] = o.DisplayName.Get()
	}
	if o.AccountId.IsSet() {
		toSerialize["accountId"] = o.AccountId.Get()
	}
	if o.ApplicationId.IsSet() {
		toSerialize["applicationId"] = o.ApplicationId.Get()
	}
	if o.IpAddress.IsSet() {
		toSerialize["ipAddress"] = o.IpAddress.Get()
	}
	if o.OperationType.IsSet() {
		toSerialize["operationType"] = o.OperationType.Get()
	}
	if !IsNil(o.Authorized) {
		toSerialize["authorized"] = o.Authorized
	}
	if o.AuthorizationReason.IsSet() {
		toSerialize["authorizationReason"] = o.AuthorizationReason.Get()
	}
	if !IsNil(o.Success) {
		toSerialize["success"] = o.Success
	}
	if o.Reason.IsSet() {
		toSerialize["reason"] = o.Reason.Get()
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.TargetObjectType1.IsSet() {
		toSerialize["targetObjectType1"] = o.TargetObjectType1.Get()
	}
	if o.TargetObjectId1.IsSet() {
		toSerialize["targetObjectId1"] = o.TargetObjectId1.Get()
	}
	if o.TargetObject1.IsSet() {
		toSerialize["targetObject1"] = o.TargetObject1.Get()
	}
	if o.TargetObjectType2.IsSet() {
		toSerialize["targetObjectType2"] = o.TargetObjectType2.Get()
	}
	if o.TargetObject2.IsSet() {
		toSerialize["targetObject2"] = o.TargetObject2.Get()
	}
	if o.TargetObjectId2.IsSet() {
		toSerialize["targetObjectId2"] = o.TargetObjectId2.Get()
	}
	if o.ParentObjectType.IsSet() {
		toSerialize["parentObjectType"] = o.ParentObjectType.Get()
	}
	if o.ParentObjectId.IsSet() {
		toSerialize["parentObjectId"] = o.ParentObjectId.Get()
	}
	if o.ParentObject.IsSet() {
		toSerialize["parentObject"] = o.ParentObject.Get()
	}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if !IsNil(o.CreationTime) {
		toSerialize["creationTime"] = o.CreationTime
	}
	return toSerialize, nil
}

type NullableOperationAudit struct {
	value *OperationAudit
	isSet bool
}

func (v NullableOperationAudit) Get() *OperationAudit {
	return v.value
}

func (v *NullableOperationAudit) Set(val *OperationAudit) {
	v.value = val
	v.isSet = true
}

func (v NullableOperationAudit) IsSet() bool {
	return v.isSet
}

func (v *NullableOperationAudit) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOperationAudit(val *OperationAudit) *NullableOperationAudit {
	return &NullableOperationAudit{value: val, isSet: true}
}

func (v NullableOperationAudit) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOperationAudit) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
